<template>
  <div class="user-container">
    Loading Status: {{ $apollo.loading }}
    <div class="row justify-content-center">
      <div class="col-3">
        <label class="form-label">Search</label>
        <input class="form-control" v-model="keyword" />
      </div>
    </div>
    <div class="mt-3">
      <button class="btn btn-primary" @click="searchKeyword">Search</button>
    </div>
    <table class="table">
      <thead>
        <tr>
          <th scope="col">#</th>
          <th scope="col">Name</th>
          <th scope="col">Username</th>
          <th scope="col">View Action</th>
          <th scope="col">Edit Action</th>
          <th scope="col">Delete Action</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(item, index) in dataList" :key="item.id">
          <th scope="row">{{ index + 1 }}</th>
          <td>{{ item.name }}</td>
          <td>{{ item.username }}</td>
          <td>
            <button class="btn btn-primary" @click="viewUser(item.id)">
              View
            </button>
          </td>
          <td>
            <button class="btn btn-primary" @click="editUser(item)">
              Edit
            </button>
          </td>
          <td>
            <button class="btn btn-primary" @click="deleteUser(item.id)">
              Delete
            </button>
          </td>
        </tr>
      </tbody>
    </table>
    <div class="row justify-content-center">
      <div class="col-3">
        <label class="form-label">Name</label>
        <input class="form-control" v-model="formData.name" />
      </div>
    </div>
    <div class="row justify-content-center">
      <div class="col-3">
        <label class="form-label">Username</label>
        <input class="form-control" v-model="formData.username" />
      </div>
    </div>
    <button class="mt-3 btn btn-primary" @click="submitAction">Submit</button>
    <div v-if="viewList.length > 0">
      <table class="table">
        <thead>
          <tr>
            <th scope="col">#</th>
            <th scope="col">Title</th>
            <th scope="col">Body</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="(item, index) in viewList" :key="item.id">
            <th scope="row">{{ index + 1 }}</th>
            <td>{{ item.title }}</td>
            <td>{{ item.body }}</td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>
import { GET_POST_BY_USER } from "@/graphql/post/query";
import {
  CREATE_USER,
  UPDATE_USER,
  DELETE_USER,
  GET_USERS,
} from "@/graphql/user/query";

export default {
  apollo: {
    users: {
      query: GET_USERS,
      variables() {
        const { options } = this;
        return { options };
      },
    },
  },
  computed: {
    dataList() {
      const { users } = this;
      return users?.data || [];
    },
    viewList() {
      const { postList } = this;
      return postList;
    },
  },
  data: () => ({
    formData: {},
    options: {
      paginate: {
        page: 1,
        limit: 5,
      },
      search: {
        q: "",
      },
    },
    keyword: "",
    postList: [],
  }),
  methods: {
    async viewUser(id) {
      const res = await this.$apollo.query({
        query: GET_POST_BY_USER,
        variables: {
          id,
        },
      });
      const { data } = res?.data?.user?.posts;
      this.postList = data;
    },
    editUser(item) {
      this.formData = {
        ...item,
      };
    },
    async deleteUser(id) {
      await this.$apollo.mutate({
        // Query
        mutation: DELETE_USER,
        // Parameters
        variables: {
          id,
        },
      });
    },
    async submitAction() {
      const { formData } = this;
      if (formData.id) {
        await this.$apollo.mutate({
          // Query
          mutation: UPDATE_USER,
          // Parameters
          variables: {
            id: formData.id,
            input: {
              name: formData.name,
              username: formData.username,
            },
          },
        });
      } else {
        await this.$apollo.mutate({
          // Query
          mutation: CREATE_USER,
          // Parameters
          variables: {
            input: formData,
          },
        });
      }
    },
    async searchKeyword() {
      this.options = {
        ...this.options,
        search: {
          q: this.keyword,
        },
      };
    },
  },
};
</script>
